//
//  tgxf-receive.h
//  TGXF
//
//  Created by James Hudson on 3/03/2014.
//  Copyright (c) 2014 James Hudson. All rights reserved.
//

#ifndef TGXF_RECEIVE_H_
#define TGXF_RECEIVE_H_

#include <zbar.h>

enum TgxfReceiveState {
    TGXF_RECEIVE_STATE_IN_PROGRESS,
    TGXF_RECEIVE_STATE_FAILED,
    TGXF_RECEIVE_STATE_SUCCEEDED
};

void tgxf_reset();
enum TgxfReceiveState decode_tgxf_frame(const zbar_symbol_t *sym, const char * filePath);

int tgxf_get_current_frame_num();
int tgxf_get_total_num_frames();
int tgxf_get_num_errors();
void tgxf_set_max_errors(int num);
void tgxf_set_max_timeout(int num);
int tgxf_get_fps();
const char * tgxf_get_filename();


#endif
