package com.midnightcode.thruglassxfer_android;

import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.ActionBar;
import android.support.v4.app.Fragment;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.os.Build;

public class OptionsActivity extends ActionBarActivity {

	private OnSeekBarChangeListener frameResolutionChangeHandler = new OnSeekBarChangeListener() {
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			int val = 0;
			switch(seekBar.getProgress()) {
	        case 0:
	            val = 1;
	            break;
	        case 1:
	            val = 2;
	            break;
	        case 2:
	            val = 8;
	            break;
	        case 3:
	            val = 15;
	            break;
	    }

			SharedPreferences settings = getSharedPreferences("tgxf", 0);
			settings.edit().putInt("FrameResolution", val).commit();
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {}
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {}
	};

	private OnSeekBarChangeListener framesPerSecondChangeHandler = new OnSeekBarChangeListener() {
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			int val = 0;
			switch(seekBar.getProgress()) {
	        case 0:
	            val = 1;
	            break;
	        case 1:
	            val = 2;
	            break;
	        case 2:
	            val = 5;
	            break;
	        case 3:
	            val = 8;
	            break;
	        case 4:
	            val = 10;
	            break;
	    }

			SharedPreferences settings = getSharedPreferences("tgxf", 0);
			settings.edit().putInt("FramesPerSecond", val).commit();
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {}
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {}
	};
	
	private OnSeekBarChangeListener maxErrorsChangeHandler = new OnSeekBarChangeListener() {
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			int val = 0;
			switch(seekBar.getProgress()) {
	        case 0:
	            val = 0;
	            break;
	        case 1:
	            val = 5;
	            break;
	        case 2:
	            val = 10;
	            break;
	        case 3:
	            val = 50;
	            break;
	    }

			SharedPreferences settings = getSharedPreferences("tgxf", 0);
			settings.edit().putInt("MaxErrors", val).commit();
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {

			
		}
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {}
	};
	
	private OnSeekBarChangeListener timeoutChangeHandler = new OnSeekBarChangeListener() {
		
		@Override
		public void onStopTrackingTouch(SeekBar seekBar) {
			int val = 0;
			switch(seekBar.getProgress()) {
	        case 0:
	            val = 0;
	            break;
	        case 1:
	            val = 5;
	            break;
	        case 2:
	            val = 10;
	            break;
	        case 3:
	            val = 50;
	            break;
	    }

			SharedPreferences settings = getSharedPreferences("tgxf", 0);
			settings.edit().putInt("Timeout", val).commit();
		}
		
		@Override
		public void onStartTrackingTouch(SeekBar seekBar) {			
		}
		
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress,
				boolean fromUser) {}
	};
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_options);

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		
		if (savedInstanceState == null) {
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, new PlaceholderFragment()).commit();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		//getMenuInflater().inflate(R.menu.options, menu);
		return false;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	/**
	 * A placeholder fragment containing a simple view.
	 */
	public static class PlaceholderFragment extends Fragment {

		public PlaceholderFragment() {
		}

		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			View rootView = inflater.inflate(R.layout.fragment_options,
					container, false);
			
			((OptionsActivity)getActivity()).setSliders(rootView);
			
			return rootView;
		}
	}

	public void setSliders(View rootView) {
		final SharedPreferences settings = getSharedPreferences("tgxf", 0);
        
        SeekBar frameResolutionSlider = (SeekBar)rootView.findViewById(R.id.frameResolutionSlider);
        SeekBar framesPerSecondSlider = (SeekBar)rootView.findViewById(R.id.framesPerSecondSlider);
        SeekBar maxErrorsSlider = (SeekBar)rootView.findViewById(R.id.maxErrorsSlider);
        SeekBar timeoutSlider = (SeekBar)rootView.findViewById(R.id.timeoutSlider);
        
        frameResolutionSlider.setOnSeekBarChangeListener(frameResolutionChangeHandler);
        framesPerSecondSlider.setOnSeekBarChangeListener(framesPerSecondChangeHandler);
        maxErrorsSlider.setOnSeekBarChangeListener(maxErrorsChangeHandler);
        timeoutSlider.setOnSeekBarChangeListener(timeoutChangeHandler);
        
      //  SeekBar framesPerSecondSlider = (SeekBar)findViewById(R.id.framesPerSecondSlider);
        
	    switch(settings.getInt("FrameResolution", 8)) {
	            // actual values are 1 (21x21), 2 (25x25), 8 (49x49), 15 (77x77)
	        case 1: frameResolutionSlider.setProgress(0); break;
	        case 2: frameResolutionSlider.setProgress(1); break;
	        case 8: frameResolutionSlider.setProgress(2); break;
	        case 15: frameResolutionSlider.setProgress(3); break;
	    }
	    
	   switch(settings.getInt("FramesPerSecond", 1)) {
	        case 1: framesPerSecondSlider.setProgress(0); break;
	        case 2: framesPerSecondSlider.setProgress(1); break;
	        case 5: framesPerSecondSlider.setProgress(2); break;
	        case 8: framesPerSecondSlider.setProgress(3); break;
	        case 10: framesPerSecondSlider.setProgress(4); break;
	    }
	  
	    switch(settings.getInt("MaxErrors", 0)) {
	        case 0: maxErrorsSlider.setProgress(0); break;
	        case 5: maxErrorsSlider.setProgress(1); break;
	        case 10: maxErrorsSlider.setProgress(2); break;
	        case 50: maxErrorsSlider.setProgress(3); break;
	    }
	    
	    switch(settings.getInt("Timeout", 10)) {
	        case 0: timeoutSlider.setProgress(0); break;
	        case 5: timeoutSlider.setProgress(1); break;
	        case 10: timeoutSlider.setProgress(2); break;
	        case 50: timeoutSlider.setProgress(3); break;
	    }

	}

}
